Loading...
Searching...
No Matches
wayland::seat_t Class Reference

group of input devices More...

`#include <wayland-client-protocol.hpp>`

Inheritance diagram for wayland::seat_t:
[legend]
Collaboration diagram for wayland::seat_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

pointer_t | get_pointer ()
| return pointer object
keyboard_t | get_keyboard ()
| return keyboard object
touch_t | get_touch ()
| return touch object
void | release ()
| release the seat object
bool | can_release () const
| Check whether the release function is available with the currently bound version of the protocol.
std::function< void(seat_capability)> & | on_capabilities ()
| seat capabilities changed
std::function< void(std::string)> & | on_name ()
| unique identifier for this seat
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | get_pointer_since_version = 1
| Minimum protocol version required for the get_pointer function.
static constexpr std::uint32_t | get_keyboard_since_version = 1
| Minimum protocol version required for the get_keyboard function.
static constexpr std::uint32_t | get_touch_since_version = 1
| Minimum protocol version required for the get_touch function.
static constexpr std::uint32_t | release_since_version = 5
| Minimum protocol version required for the release function.

## Detailed Description

group of input devices

A seat is a group of keyboards, pointer and touch devices. This object is published as a global during start up, or when such a device is hot plugged. A seat typically has a pointer and maintains a keyboard focus and a pointer focus.

Examples
  egl.cpp, proxy_wrapper.cpp, and shm.cpp.

Definition at line 2490 of file wayland-client-protocol.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## can_release()

bool seat_t::can_release | ( |  | ) | const

Check whether the release function is available with the currently bound version of the protocol.

Definition at line 2875 of file wayland-client-protocol.cpp.

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_keyboard()

keyboard_t seat_t::get_keyboard | ( |  | ) |

return keyboard object

Returns
  seat keyboard

The ID provided will be initialized to the wl_keyboard interface for this seat.

This request only takes effect if the seat has the keyboard capability, or has had the keyboard capability in the past. It is a protocol violation to issue this request on a seat that has never had the keyboard capability. The missing_capability error will be sent in this case.

Examples
  egl.cpp, proxy_wrapper.cpp, and shm.cpp.

Definition at line 2856 of file wayland-client-protocol.cpp.

## get_pointer()

pointer_t seat_t::get_pointer | ( |  | ) |

return pointer object

Returns
  seat pointer

The ID provided will be initialized to the wl_pointer interface for this seat.

This request only takes effect if the seat has the pointer capability, or has had the pointer capability in the past. It is a protocol violation to issue this request on a seat that has never had the pointer capability. The missing_capability error will be sent in this case.

Examples
  egl.cpp, and shm.cpp.

Definition at line 2849 of file wayland-client-protocol.cpp.

## get_touch()

touch_t seat_t::get_touch | ( |  | ) |

return touch object

Returns
  seat touch interface

The ID provided will be initialized to the wl_touch interface for this seat.

This request only takes effect if the seat has the touch capability, or has had the touch capability in the past. It is a protocol violation to issue this request on a seat that has never had the touch capability. The missing_capability error will be sent in this case.

Definition at line 2863 of file wayland-client-protocol.cpp.

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

## on_capabilities()

std::function< void(seat_capability)> & seat_t::on_capabilities | ( |  | ) |

seat capabilities changed

Parameters

  capabilities | capabilities of the seat

This is emitted whenever a seat gains or loses the pointer, keyboard or touch capabilities. The argument is a capability enum containing the complete set of capabilities this seat has.

When the pointer capability is added, a client may create a wl_pointer object using the wl_seat.get_pointer request. This object will receive pointer events until the capability is removed in the future.

When the pointer capability is removed, a client should destroy the wl_pointer objects associated with the seat where the capability was removed, using the wl_pointer.release request. No further pointer events will be received on these objects.

In some compositors, if a seat regains the pointer capability and a client has a previously obtained wl_pointer object of version 4 or less, that object may start sending pointer events again. This behavior is considered a misinterpretation of the intended behavior and must not be relied upon by the client. wl_pointer objects of version 5 or later must not send events if created before the most recent event notifying the client of an added pointer capability.

The above behavior also applies to wl_keyboard and wl_touch with the keyboard and touch capabilities, respectively.

Examples
  egl.cpp, and shm.cpp.

Definition at line 2881 of file wayland-client-protocol.cpp.

## on_name()

std::function< void(std::string)> & seat_t::on_name | ( |  | ) |

unique identifier for this seat

Parameters

  name | seat identifier

In a multi-seat configuration the seat name can be used by clients to help identify which physical devices the seat represents.

The seat name is a UTF-8 string with no convention defined for its contents. Each name is unique among all wl_seat globals. The name is only guaranteed to be unique for the current compositor instance.

The same seat names are used for all clients. Thus, the name can be shared across processes to refer to a specific wl_seat global.

The name event is sent after binding to the seat global. This event is only sent once per seat object, and the name does not change over the lifetime of the wl_seat global.

Compositors may re-use the same seat name if the wl_seat global is destroyed and re-created later.

Definition at line 2886 of file wayland-client-protocol.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## release()

void seat_t::release | ( |  | ) |

release the seat object

Using this request a client can tell the server that it is not going to use the seat object anymore.

Definition at line 2870 of file wayland-client-protocol.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## Member Data Documentation

## get_keyboard_since_version

constexpr std::uint32_t wayland::seat_t::get_keyboard_since_version = 1

static constexpr

Minimum protocol version required for the get_keyboard function.

Definition at line 2550 of file wayland-client-protocol.hpp.

## get_pointer_since_version

constexpr std::uint32_t wayland::seat_t::get_pointer_since_version = 1

static constexpr

Minimum protocol version required for the get_pointer function.

Definition at line 2531 of file wayland-client-protocol.hpp.

## get_touch_since_version

constexpr std::uint32_t wayland::seat_t::get_touch_since_version = 1

static constexpr

Minimum protocol version required for the get_touch function.

Definition at line 2569 of file wayland-client-protocol.hpp.

## release_since_version

constexpr std::uint32_t wayland::seat_t::release_since_version = 5

static constexpr

Minimum protocol version required for the release function.

Definition at line 2581 of file wayland-client-protocol.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol.cpp